<!doctype html>
<html>
<head>
    <title>New Feature: Tor Interpreter | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="New Feature: Tor Interpreter | Tor Project">
    <meta property="og:description" content="Hi all, after a couple months down in the engine room I&#39;m delighted to announce a new Stem...">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/new-feature-tor-interpreter/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        New Feature: Tor Interpreter
      </h1>
    <p class="meta">by atagar | May 26, 2014</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>Hi all, after a couple months down in the engine room I'm delighted to announce a new Stem feature for advanced Tor users and developers!</p>

<p><b><a href="https://stem.torproject.org/tutorials/down_the_rabbit_hole.html" rel="nofollow">Stem's Interpreter Tutoral</a></b></p>

<p>The control interpreter is a new method for interacting with Tor's control interface that combines an interactive python interpreter with raw access similar to telnet. This adds several usability features, such as...</p>

<ul>
<li>Irc-style commands like '/help'.</li>
<li>Tab completion for Tor's controller commands.</li>
<li>History scrollback by pressing up/down.</li>
<li>Transparently handles Tor authentication at startup.</li>
<li>Colorized output for improved readability.</li>
</ul>

<p>This is the last major feature going into the Stem's 1.2.0 release, which is coming out later this month. Until then you can easily give it a whirl with...</p>

<p>% git clone <a href="https://git.torproject.org/stem.git" rel="nofollow">https://git.torproject.org/stem.git</a><br />
% cd stem<br />
% ./tor-prompt</p>

<p>Running into an issue? Got a feature request? As always feedback appreciated! -Damian</p>

    </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-61787"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-61787" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">May 26, 2014</p>
    </div>
    <a href="#comment-61787">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-61787" class="permalink" rel="bookmark">Neat! Nicely done.</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Neat! Nicely done.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-61815"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-61815" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">May 26, 2014</p>
    </div>
    <a href="#comment-61815">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-61815" class="permalink" rel="bookmark">We have some questions for</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>We have some questions for you Damian:</p>
<p>1. Are you working for the NSA?</p>
<p>2. Have you ever been approached by the NSA to insert backdoors in your software? (You can give a verbal "yes" with a shaking of the head to signify "no")</p>
<p>3. Are there backdoors in the Stem's interpreter for the NSA to make use of?</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-61927"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-61927" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">May 28, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-61815" class="permalink" rel="bookmark">We have some questions for</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-61927">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-61927" class="permalink" rel="bookmark">[[Edit: I  spent a while</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>[[Edit: I  spent a while trying to figure out if I should moderate this comment from an anonymous user or what -- but I decided to let it go through intact. Note that the real Damian answers below, and this is some person trolling you. But hey, make up your own mind. :) --Roger]]</p>
<p>&gt;1. Are you working for the NSA?<br />
Yes.</p>
<p>&gt;2. Have you ever been approached by the NSA to insert backdoors in your software? ?(You can give a verbal "yes" with a shaking of the head to signify "no")<br />
Yes and we have.</p>
<p>&gt;3. Are there backdoors in the Stem's interpreter for the NSA to make use of?<br />
Of course.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-62433"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-62433" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">June 01, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-61927" class="permalink" rel="bookmark">[[Edit: I  spent a while</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-62433">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-62433" class="permalink" rel="bookmark">Yes ! We Can !</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Yes ! We Can !</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div></div><a id="comment-61820"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-61820" class="contextual-region comment js-comment by-node-author" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  atagar
  </article>
    <div class="comment-header">
      <p class="comment__submitted">atagar said:</p>
      <p class="date-time">May 26, 2014</p>
    </div>
    <a href="#comment-61820">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-61820" class="permalink" rel="bookmark">For all three questions the</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>For all three questions the answer is nope. On a side note the interpreter is a pretty small codebase so it would be easy to audit if you're really that concerned.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-61966"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-61966" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">May 28, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to atagar</p>
    <a href="#comment-61966">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-61966" class="permalink" rel="bookmark">thank you for this post</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>thank you for this post</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div><a id="comment-61833"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-61833" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">May 26, 2014</p>
    </div>
    <a href="#comment-61833">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-61833" class="permalink" rel="bookmark">A lot of time the my TBB is</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>A lot of time the my TBB is too slowly than it should be, here is a trick.</p>
<p>First you get the Vidalia standalone (me downloads i686), then you can see the connection and the status in Tor Network Map. If you feel the network slowly than it should be, delete the related connection (maybe named node or relay) from the Tor Network Map. Now you can see some nodes status is new, if 1 second later it is still new, delete it. If you see the nodes status is building...The new node will build and may help you visited the internet. If not, keep deleting and refreshing your Firefox ( yes, some times deleting the node will make your browser stop connecting to internet) until you the traffic in Tor Bandwidth Usage is not zero.</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-62130"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-62130" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">May 30, 2014</p>
    </div>
    <a href="#comment-62130">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-62130" class="permalink" rel="bookmark">Can SOMEONE from the</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Can SOMEONE from the torproject PLEASE REMOVE Startpage.com and Ixquick.com as the STANDARD Search Engine??? </p>
<p>They LOG STUFF ABOUT YOU! So the OTHER DAY Im using TOR with a GERMAN IP. Just Searched for "DEPRESSION" on IXQUICK. Guess what result I got first? <a href="http://www.depression-grind.de" rel="nofollow">www.depression-grind.de</a> (NON-sponsored-site) - A GERMAN WEBSITE. I CHANGED the IP addres (New IDENTITY Button). Search for DEPRESSION again. FIRST RESULT is COMPLETELY DIFFERENT!!!!!!!</p>
<p>THEY...LOG...YOUR...COUNTRY...AND...PROBABLY...IP...TOO</p>
</div>
  </div>
</article>
<!-- Comment END -->
<div class="indented"><a id="comment-63043"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-63043" class="contextual-region comment js-comment" id="comment-">
  <footer class="comment__meta">
    <article class="contextual-region">
  arma
  </article>
    <div class="comment-header">
      <p class="comment__submitted">arma said:</p>
      <p class="date-time">June 12, 2014</p>
    </div>
              <p class="parent visually-hidden">In reply to <a href="#comment-62130" class="permalink" rel="bookmark">Can SOMEONE from the</a> by <span>Anonymous (not verified)</span></p>
    <a href="#comment-63043">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-63043" class="permalink" rel="bookmark">If you&#039;re using Tor, they</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>If you're using Tor, they don't get your country or your IP address. That's one of the many goals of Tor.</p>
<p>More broadly though, we're running pretty low on search engines that don't suck and that don't make it really tough to interact with them over Tor. Maybe we've run out entirely, in fact, if we want to achieve both of those properties.</p>
</div>
  </div>
</article>
<!-- Comment END -->
</div>
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
